'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
// This was taken from json-package by the brilliant @bahmutov
// https://github.com/bahmutov/json-package/blob/10aa0eccff7a8c81fd21ad3322cf83b205f4f46a/src/find-scripts.js

exports.default = findScripts;


function findScripts(prefix, scripts) {
  var labels = Object.keys(scripts);
  var matchesExactlyPrefix = matchesExactly.bind(null, prefix);
  var exactMatches = labels.filter(matchesExactlyPrefix);
  if (exactMatches.length === 1) {
    return exactMatches;
  }

  var startsWithPrefix = startsWith.bind(null, prefix);
  var matchingScripts = labels.filter(startsWithPrefix);
  return matchingScripts;
}

function startsWith(prefix, str) {
  console.assert(typeof str === 'string', 'expected string', str); // eslint-disable-line no-console
  return str.indexOf(prefix) === 0;
}

function sameLength(a, b) {
  return a.length === b.length;
}

function matchesExactly(prefix, str) {
  return startsWith(prefix, str) && sameLength(prefix, str);
}